# BLUPF90 UNE Course - Lab 5 - metafounders
# Daniela Lourenco

#1) Using metafounders to set the base populations
## validation is done to investigate whether metafounders are helping 
## to increase accuracy and reduce dispersion in this population

#Without MF
mkdir ssgblup; cd ssgblup
cp ../renum.par .
ln -s ../newped.txt .
ln -s ../snp_file.txt .
sed -i 's:newdata.txt:../newdata.txt:g' renum.par
cp ../renum.sh .
bash renum.sh &

echo 'ulimit -s unlimited
export OMP_STACKSIZE=128M
blupf90+ <<AA > ssgblup.log
renf90.par
AA' > ssgblup.sh
bash ssgblup.sh &

#reduced data for validation
mkdir val; cd val
awk '$4<10' ../renf90.dat > renf90_val.dat
cp ../renf90.par .
sed -i 's:renf90.dat:renf90_val.dat:g' renf90.par
sed -i 's:snp_file.txt:../snp_file.txt:g' renf90.par
sed -i 's:renadd02.ped:../renadd02.ped:g' renf90.par
cp ../ssgblup.sh .
bash ssgblup.sh &


#With MF
cd ../../
mkdir mf_ssgblup; cd mf_ssgblup
awk '{if ($4==0 && $7==1) print $1,-1,-1; else if ($4==0 && $7==2) print $1,-2,-2; else print $1,$2,$3}' ../newdata.txt > mfped.txt
ln -s ../snp_file.txt .
cp ../renum.par .
sed -i '25i\UPG_TYPE' renum.par
sed -i '26i\in_pedigrees' renum.par
sed -i 's:newdata.txt:../newdata.txt:g' renum.par
sed -i 's:newped.txt:mfped.txt:g' renum.par
cp ../renum.sh .
bash renum.sh &

gammaf90 --snpfile snp_file.txt --pedfile renadd02.ped

cp gamma.txt renadd02.ped_gamma
cp renf90.par grenf90.par
sed -i 's:add_an_upginb:add_an_meta:g' grenf90.par

echo 'ulimit -s unlimited
export OMP_STACKSIZE=128M
blupf90test <<AA > ssgblup.log
grenf90.par
AA' > ssgblup.sh
bash ssgblup.sh &

#reduced data for validation
mkdir val; cd val
awk '$4<10' ../renf90.dat > renf90_val.dat
cp ../grenf90.par .
sed -i 's:renf90.dat:renf90_val.dat:g' grenf90.par
sed -i 's:snp_file.txt:../snp_file.txt:g' grenf90.par
sed -i 's:renadd02.ped:../renadd02.ped:g' grenf90.par
cp ../ssgblup.sh .
bash ssgblup.sh &


#Validation
cd ../../
mkdir validation; cd validation
awk '$4==10{print $1,$6}' ../newdata.txt | sort +0 -1 > tbv.temp

awk '$6>=10{print $10,$1}' ../ssgblup/renadd02.ped | sort +0 -1 > id.temp
join -1 +1 -2 +1 id.temp tbv.temp | awk '{print $2,$1,$3}' | sort +0 -1 > id.tbv.temp
awk '$2==2{print $3,$4}' ../ssgblup/solutions | sort +0 -1 > sol.temp
join -1 +1 -2 +1 id.tbv.temp sol.temp > tbv.sol

awk '$6>=10{print $10,$1}' ../mf_ssgblup/renadd02.ped | sort +0 -1 > mf_id.temp
join -1 +1 -2 +1 mf_id.temp tbv.temp | awk '{print $2,$1,$3}' | sort +0 -1 > mf_id.tbv.temp
awk '$2==2{print $3,$4}' ../mf_ssgblup/solutions | sort +0 -1 > mf_sol.temp
join -1 +1 -2 +1 mf_id.tbv.temp mf_sol.temp > mf_tbv.sol

#Start R for calculations:
R
ssgblup=read.table(file="tbv.sol")
colnames(ssgblup)<- c("id", "orig_id", "tbv", "gebv")

mf_ssgblup=read.table(file="mf_tbv.sol")
colnames(mf_ssgblup)<- c("id", "orig_id", "tbv", "gebv")

# Accuracy as COR(TBV,GEBV)
round(cor(ssgblup$tbv,ssgblup$gebv,use="pairwise.complete.obs"),2)
round(cor(mf_ssgblup$tbv,mf_ssgblup$gebv,use="pairwise.complete.obs"),2)

#Regression TBV ~ GEBV
reg=lm(ssgblup$tbv~ssgblup$gebv)
summary(reg)

#Regression TBV~GEBV
reg2=lm(mf_ssgblup$tbv~mf_ssgblup$gebv)
summary(reg2)



curl http://nce.ads.uga.edu/wiki/lib/exe/fetch.php?media=lab5_une.zip -o gammaf90.date.gz
